(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('mtm-utilities', ['exports', '@angular/core'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['mtm-utilities'] = {}, global.ng.core));
}(this, (function (exports, i0) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var BaseFactory = /** @class */ (function () {
        function BaseFactory() {
            this._mtmAuto = null;
        }
        BaseFactory.prototype.setAuto = function (service) {
            this._mtmAuto = service;
            return this;
        };
        BaseFactory.prototype.getAuto = function () {
            return this._mtmAuto;
        };
        return BaseFactory;
    }());

    var BaseTool = /** @class */ (function () {
        function BaseTool() {
            this._mtmAuto = null;
        }
        BaseTool.prototype.setAuto = function (service) {
            this._mtmAuto = service;
            return this;
        };
        BaseTool.prototype.getAuto = function () {
            return this._mtmAuto;
        };
        return BaseTool;
    }());

    var v4 = /** @class */ (function (_super) {
        __extends(v4, _super);
        function v4() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //USE: this.getAuto().get("utilities").getGuids().getV4().__METHOD__();
        v4.prototype.get = function (inclBraces) {
            if (inclBraces === void 0) { inclBraces = true; }
            //replace the s4 function with random string from 
            function s4() {
                return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
            }
            var guid = (s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4()).toUpperCase();
            if (inclBraces === true) {
                return "[" + guid + "]";
            }
            else {
                return guid;
            }
        };
        v4.prototype.isValid = function (input, inclBraces, throwOnErr) {
            if (inclBraces === void 0) { inclBraces = true; }
            if (throwOnErr === void 0) { throwOnErr = false; }
            var isValid = true;
            if (typeof input === "string") {
                if (inclBraces === true) {
                    if (input.length !== 38) {
                        isValid = false;
                    }
                    else if (input.slice(input.length - 1) !== "]") {
                        isValid = false;
                    }
                    else if (input.slice(0, 1) !== "[") {
                        isValid = false;
                    }
                    else {
                        input = input.substring(1, input.length - 1);
                    }
                }
                else if (input.length !== 36) {
                    isValid = false;
                }
                if (isValid === true) {
                    var parts = input.split("-");
                    if (parts.length === 5) {
                        if (parts[0].length === 8
                            || parts[1].length === 4
                            || parts[2].length === 4
                            || parts[3].length === 4
                            || parts[4].length === 12) {
                            var regex = /^[A-F0-9]+$/;
                            if (parts.join("").match(regex) === null) {
                                isValid = false;
                            }
                        }
                        else {
                            isValid = false;
                        }
                    }
                    else {
                        isValid = false;
                    }
                }
            }
            else {
                isValid = false;
            }
            if (isValid === true) {
                return true;
            }
            else if (throwOnErr === true) {
                throw this.getAuto().newException("Invalid v4 guid", 7869);
            }
            else {
                return false;
            }
        };
        return v4;
    }(BaseTool));

    var Guids = /** @class */ (function (_super) {
        __extends(Guids, _super);
        function Guids() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._v4 = null;
            return _this;
        }
        Guids.prototype.getV4 = function () {
            if (this._v4 === null) {
                this._v4 = new v4();
                this._v4.setAuto(this.getAuto());
            }
            return this._v4;
        };
        return Guids;
    }(BaseFactory));

    var Strings = /** @class */ (function (_super) {
        __extends(Strings, _super);
        function Strings() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //USE: this.getAuto().get("utilities").getArrays().getStrings().__METHOD__();
        Strings.prototype.fromBuffer = function (buf) {
            return String.fromCharCode.apply(null, new Uint8Array(buf));
        };
        return Strings;
    }(BaseTool));

    var Objects = /** @class */ (function (_super) {
        __extends(Objects, _super);
        function Objects() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //USE: this.getAuto().get("utilities").getArrays().getObjects().__METHOD__();
        Objects.prototype.isValid = function (input, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            if (Array.isArray(input) === true) {
                return true;
            }
            else if (throwOnErr === true) {
                throw this.getAuto().newException("Input is not an array object", 7885);
            }
            else {
                return false;
            }
        };
        Objects.prototype.isLength = function (input, len, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.isValid(input, true);
            if (input.length === len) {
                return true;
            }
            else if (throwOnErr === true) {
                throw this.getAuto().newException("Input does not have the correct length", 7880);
            }
            else {
                return false;
            }
        };
        Objects.prototype.isMaxLength = function (input, len, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.isValid(input, true);
            if (input.length <= len) {
                return true;
            }
            else if (throwOnErr === true) {
                throw this.getAuto().newException("Input exceeds the max length", 7886);
            }
            else {
                return false;
            }
        };
        Objects.prototype.isMinLength = function (input, len, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.isValid(input, true);
            if (input.length >= len) {
                return true;
            }
            else if (throwOnErr === true) {
                throw this.getAuto().newException("Input does not meet the minimum length", 7887);
            }
            else {
                return false;
            }
        };
        return Objects;
    }(BaseTool));

    var Arrays = /** @class */ (function (_super) {
        __extends(Arrays, _super);
        function Arrays() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._strTool = null;
            _this._objTool = null;
            return _this;
        }
        Arrays.prototype.getStrings = function () {
            if (this._strTool === null) {
                this._strTool = new Strings();
                this._strTool.setAuto(this.getAuto());
            }
            return this._strTool;
        };
        Arrays.prototype.getObjects = function () {
            if (this._objTool === null) {
                this._objTool = new Objects();
                this._objTool.setAuto(this.getAuto());
            }
            return this._objTool;
        };
        return Arrays;
    }(BaseFactory));

    var Random = /** @class */ (function (_super) {
        __extends(Random, _super);
        function Random() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Random.prototype.getByRegex = function (len, regex) {
            if (regex === void 0) { regex = "A-Za-z0-9\\#\\-\\+\\:\\;\\.\\,\\!"; }
            try {
                var str = "";
                var chars = this.getAuto().get("utilities").getStrings().getCharacterSets().getAsciiPrintable();
                var uChars = chars.replace(new RegExp("[^" + regex + "]", "g"), "");
                var charLen = uChars.length;
            }
            catch (e) {
                throw this.getAuto().newException("Failed to limit character set exception: " + e);
            }
            if (charLen > 0) {
                for (var i = 0; i < len; i++) {
                    str += uChars.charAt(Math.floor(Math.random() * charLen));
                }
                return str;
            }
            else {
                throw this.getAuto().newException("Invalid regex");
            }
        };
        return Random;
    }(BaseTool));

    var Urls = /** @class */ (function (_super) {
        __extends(Urls, _super);
        function Urls() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //USE: this.getAuto().get("utilities").getStrings().getUrl().__METHOD__();
        Urls.prototype.get = function () {
            return this.parse(window.location.href);
        };
        Urls.prototype.set = function (url) {
            window.location.href = url;
            return this;
        };
        Urls.prototype.parse = function (url) {
            var items = url.split('/').filter(function (el) {
                return el != "";
            });
            //if there is no / between the path and query we need to break it up
            var lItem = items[(items.length - 1)];
            var qBreak = lItem.indexOf("?");
            if (qBreak > 0) {
                items[(items.length - 1)] = lItem.substring(0, qBreak);
                items.push(lItem.substring(qBreak));
            }
            var scheme = items[0].toLowerCase().replace(/\:$/, "");
            var host = null;
            var port = null;
            var path = null;
            var query = {};
            var ps = items[1].split(":");
            host = ps[0];
            if (ps.length == 2) {
                port = parseInt(ps[1]);
            }
            else if (scheme == "http") {
                port = 80;
            }
            else if (scheme == "https") {
                port = 443;
            }
            if (items.length > 2) {
                for (var x = 2; x < items.length; x++) {
                    var item = items[x];
                    if (item.indexOf("?") === 0) {
                        ps = item.replace(/^\?/, "").split("&");
                        for (var y = 0; y < ps.length; y++) {
                            var qItem = ps[y].split("=");
                            query[qItem[0]] = qItem[1];
                        }
                    }
                    else {
                        path = item;
                    }
                }
            }
            return { scheme: scheme, host: host, port: port, path: path, query: query };
        };
        Urls.prototype.getQueryValue = function (url, attr, doThrow) {
            if (doThrow === void 0) { doThrow = false; }
            var pObj = this.parse(url);
            if (typeof pObj.query[attr] != "undefined") {
                return pObj.query[attr];
            }
            else if (doThrow === true) {
                throw this.getAuto().newException("Atribute: '" + attr + "' does not exist");
            }
            else {
                return null;
            }
        };
        return Urls;
    }(BaseTool));

    var Arrays$1 = /** @class */ (function (_super) {
        __extends(Arrays, _super);
        function Arrays() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Arrays.prototype.toBuffer = function (str) {
            var buf = new ArrayBuffer(str.length);
            var buf2 = new Uint8Array(buf);
            for (var x = 0, strLen = str.length; x < strLen; x++) {
                buf2[x] = str.charCodeAt(x);
            }
            return buf;
        };
        return Arrays;
    }(BaseTool));

    var Passwords = /** @class */ (function (_super) {
        __extends(Passwords, _super);
        function Passwords() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //Use:
        //var any	= something.getAuto().get("utilities").getStrings().getPasswords().__METHOD__();
        Passwords.prototype.getHumanV1 = function (len) {
            if (len === void 0) { len = 9; }
            //prebuilt to fulfill the V1 requirements but excludes characters that can appear ambigous
            if (len < 9) {
                throw this.getAuto().newException("V1 passwords must be at least 9 character");
            }
            var regEx = "A-Ha-hJ-Nm-nP-Zp-z1-9\\#\\+\\-\\_\\@\\&\\%\\$\\*";
            var toolObj = this.getAuto().get("utilities").getStrings().getRandom();
            while (true) {
                var password = toolObj.getByRegex(len, regEx);
                if (this.validV1(password, false) === true) {
                    return password;
                }
            }
        };
        Passwords.prototype.getV1 = function (len) {
            if (len === void 0) { len = 9; }
            //prebuilt to fulfill the V1 requirements
            if (len < 9) {
                throw this.getAuto().newException("V1 passwords must be at least 9 character");
            }
            var regEx = "A-Za-z0-9\\!\\#\\$\\%\\&\\'\\(\\)\\*\\+\\,\\-\\.\\/\\:\\;\\<\\=\\>\\?\\@\\{\\|\\}\\~\\[\\]\\^";
            var toolObj = this.getAuto().get("utilities").getStrings().getRandom();
            while (true) {
                var password = toolObj.getByRegex(len, regEx);
                if (this.validV1(password, false) === true) {
                    return password;
                }
            }
        };
        Passwords.prototype.validV1 = function (input, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            //prebuilt for easy checking
            //ascii cannot start or end with a space
            //must have one upper, lower a symbol and be at least 9 char
            if (typeof input !== "string") {
                throw this.getAuto().newException("Invalid input, only accepts strings");
            }
            var isValid = true;
            var errMsg = "";
            if (isValid === true && input.length !== input.trim().length) {
                isValid = false;
                errMsg = "Cannot start or end with a space";
            }
            if (isValid === true && input.length < 9) {
                isValid = false;
                errMsg = "Password must be at least 9 character";
            }
            if (isValid === true) {
                isValid = this.asciiIncl(input, true, true, true, true, throwOnErr);
            }
            if (isValid === true) {
                return true;
            }
            else if (throwOnErr === true) {
                throw this.getAuto().newException("Password is invalid. " + errMsg);
            }
            else {
                return false;
            }
        };
        Passwords.prototype.asciiIncl = function (input, upper, lower, number, symbol, throwOnErr) {
            if (upper === void 0) { upper = true; }
            if (lower === void 0) { lower = true; }
            if (number === void 0) { number = true; }
            if (symbol === void 0) { symbol = true; }
            if (throwOnErr === void 0) { throwOnErr = false; }
            if (typeof input !== "string") {
                throw this.getAuto().newException("Invalid input, only accepts strings");
            }
            var isValid = true;
            var errMsg = "";
            var regTool = this.getAuto().get("utilities").getExpressions().getRegEx();
            var charTool = this.getAuto().get("utilities").getStrings().getCharacterSets();
            if (isValid === true && upper === true) {
                var regex = RegExp("[" + regTool.makeSafe(charTool.getAsciiUpper()) + "\]+");
                if (input.match(regex) === null) {
                    isValid = false;
                    errMsg = "Must contain atleast one uppercase letter";
                }
            }
            if (isValid === true && lower === true) {
                var regex = RegExp("[" + regTool.makeSafe(charTool.getAsciiLower()) + "\]+");
                if (input.match(regex) === null) {
                    isValid = false;
                    errMsg = "Must contain atleast one lowercase letter";
                }
            }
            if (isValid === true && number === true) {
                var regex = RegExp("[" + regTool.makeSafe(charTool.getDecimals()) + "\]+");
                if (input.match(regex) === null) {
                    isValid = false;
                    errMsg = "Must contain atleast one digit";
                }
            }
            if (isValid === true && symbol === true) {
                //we dont want space to count as a symbol
                var regex = RegExp("[" + regTool.makeSafe(charTool.getAsciiSymbols().replace(" ", "")) + "\]+");
                if (input.match(regex) === null) {
                    isValid = false;
                    errMsg = "Must contain atleast one symbol";
                }
            }
            if (isValid === true) {
                return true;
            }
            else if (throwOnErr === true) {
                throw this.getAuto().newException("Password is invalid. " + errMsg);
            }
            else {
                return false;
            }
        };
        return Passwords;
    }(BaseTool));

    var Emails = /** @class */ (function (_super) {
        __extends(Emails, _super);
        function Emails() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //USE: this.getAuto().get("utilities").getStrings().getEmail().__METHOD__();
        Emails.prototype.isValid = function (input, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            if (typeof input === "string") {
                //src: https://emailregex.com/
                var regEx = RegExp(/^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/);
                if (regEx.test(input) === true) {
                    return true;
                }
            }
            if (throwOnErr === true) {
                throw this.getAuto().newException("Invalid email address", 7866);
            }
            else {
                return false;
            }
        };
        return Emails;
    }(BaseTool));

    var String$1 = /** @class */ (function (_super) {
        __extends(String, _super);
        function String() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //USE: this.getAuto().get("utilities").getStrings().getString().__METHOD__();
        String.prototype.isValid = function (input, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            if (typeof input === "string") {
                return true;
            }
            else if (throwOnErr === true) {
                throw this.getAuto().newException("Input is not a string", 7873);
            }
            else {
                return false;
            }
        };
        String.prototype.isLength = function (input, len, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.getAuto().get("utilities").getNumbers().getIntegers().isValid(len, true);
            if (this.isValid(input, throwOnErr) === true) {
                if (input.length === len) {
                    return true;
                }
                else if (throwOnErr === true) {
                    throw this.getAuto().newException("Input string has incorrect length", 7874);
                }
            }
            return false;
        };
        String.prototype.isMaxLength = function (input, len, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.getAuto().get("utilities").getNumbers().getIntegers().isValid(len, true);
            if (this.isValid(input, throwOnErr) === true) {
                if (input.length <= len) {
                    return true;
                }
                else if (throwOnErr === true) {
                    throw this.getAuto().newException("Input string has excessive length", 7875);
                }
            }
            return false;
        };
        String.prototype.isMinLength = function (input, len, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            this.getAuto().get("utilities").getNumbers().getIntegers().isValid(len, true);
            if (this.isValid(input, throwOnErr) === true) {
                if (input.length >= len) {
                    return true;
                }
                else if (throwOnErr === true) {
                    throw this.getAuto().newException("Input string has insuficient length", 7876);
                }
            }
            return false;
        };
        return String;
    }(BaseTool));

    var MacAddresses = /** @class */ (function (_super) {
        __extends(MacAddresses, _super);
        function MacAddresses() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //USE: this.getAuto().get("utilities").getStrings().getMacAddress().__METHOD__();
        MacAddresses.prototype.isValid = function (input, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            if (typeof input === "string") {
                var regEx = RegExp(/^([a-fA-F0-9]{12})$/);
                if (regEx.test(input) === true) {
                    return true;
                }
            }
            if (throwOnErr === true) {
                throw this.getAuto().newException("Invalid mac address", 7871);
            }
            else {
                return false;
            }
        };
        return MacAddresses;
    }(BaseTool));

    var Ssid = /** @class */ (function (_super) {
        __extends(Ssid, _super);
        function Ssid() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //USE: this.getAuto().get("utilities").getStrings().getSsid().__METHOD__();
        Ssid.prototype.isValid = function (input, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            if (typeof input === "string") {
                var regEx = RegExp(/^([.]{1,32})$/); //a 0 bytes ssid is a wildcard
                if (regEx.test(input) === true) {
                    return true;
                }
            }
            if (throwOnErr === true) {
                throw this.getAuto().newException("Invalid ssid", 7879);
            }
            else {
                return false;
            }
        };
        return Ssid;
    }(BaseTool));

    var CharacterSets = /** @class */ (function (_super) {
        __extends(CharacterSets, _super);
        function CharacterSets() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //Use:
        //var chars	= something.getAuto().get("utilities").getStrings().getCharacterSets().__METHOD__();
        CharacterSets.prototype.getDecimals = function () {
            return "0123456789";
        };
        CharacterSets.prototype.getAsciiSymbols = function () {
            return "!\"#$%&'()*+,-./:;<=>?@{|}~[\\]^ _`";
        };
        CharacterSets.prototype.getAsciiLower = function () {
            return "abcdefghijklmnopqrstuvwxyz";
        };
        CharacterSets.prototype.getAsciiUpper = function () {
            return "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        };
        CharacterSets.prototype.getAsciiPrintable = function () {
            return this.getAsciiLower() + this.getAsciiUpper() + this.getDecimals() + this.getAsciiSymbols();
        };
        return CharacterSets;
    }(BaseTool));

    var Strings$1 = /** @class */ (function (_super) {
        __extends(Strings, _super);
        function Strings() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._randomTool = null;
            _this._urlTool = null;
            _this._arrTool = null;
            _this._pwTool = null;
            _this._emailTool = null;
            _this._macTool = null;
            _this._csTool = null;
            _this._strTool = null;
            _this._ssidTool = null;
            return _this;
        }
        Strings.prototype.getRandom = function () {
            if (this._randomTool === null) {
                this._randomTool = new Random();
                this._randomTool.setAuto(this.getAuto());
            }
            return this._randomTool;
        };
        Strings.prototype.getUrl = function () {
            if (this._urlTool === null) {
                this._urlTool = new Urls();
                this._urlTool.setAuto(this.getAuto());
            }
            return this._urlTool;
        };
        Strings.prototype.getString = function () {
            if (this._strTool === null) {
                this._strTool = new String$1();
                this._strTool.setAuto(this.getAuto());
            }
            return this._strTool;
        };
        Strings.prototype.getArrays = function () {
            //What are you doing here?
            if (this._arrTool === null) {
                this._arrTool = new Arrays$1();
                this._arrTool.setAuto(this.getAuto());
            }
            return this._arrTool;
        };
        Strings.prototype.getPasswords = function () {
            if (this._pwTool === null) {
                this._pwTool = new Passwords();
                this._pwTool.setAuto(this.getAuto());
            }
            return this._pwTool;
        };
        Strings.prototype.getEmail = function () {
            if (this._emailTool === null) {
                this._emailTool = new Emails();
                this._emailTool.setAuto(this.getAuto());
            }
            return this._emailTool;
        };
        Strings.prototype.getMacAddress = function () {
            if (this._macTool === null) {
                this._macTool = new MacAddresses();
                this._macTool.setAuto(this.getAuto());
            }
            return this._macTool;
        };
        Strings.prototype.getSsid = function () {
            if (this._ssidTool === null) {
                this._ssidTool = new Ssid();
                this._ssidTool.setAuto(this.getAuto());
            }
            return this._ssidTool;
        };
        Strings.prototype.getCharacterSets = function () {
            if (this._csTool === null) {
                this._csTool = new CharacterSets();
                this._csTool.setAuto(this.getAuto());
            }
            return this._csTool;
        };
        return Strings;
    }(BaseFactory));

    var Integers = /** @class */ (function (_super) {
        __extends(Integers, _super);
        function Integers() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //USE: this.getAuto().get("utilities").getNumbers().getIntegers().__METHOD__();
        Integers.prototype.isValid = function (input, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            if (typeof input === "number") {
                if (Number.isInteger(input) === true) {
                    return true;
                }
            }
            if (throwOnErr === true) {
                throw this.getAuto().newException("Invalid integer", 7872);
            }
            else {
                return false;
            }
        };
        Integers.prototype.isStringInteger = function (input, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            //is the input an integer cast as a string?
            if (typeof input === "string") {
                var regEx = RegExp(/^\d+$/);
                if (regEx.test(input) === true) {
                    return true;
                }
            }
            if (throwOnErr === true) {
                throw this.getAuto().newException("Input is not an integer typed as a string", 7877);
            }
            else {
                return false;
            }
        };
        return Integers;
    }(BaseTool));

    var Numbers = /** @class */ (function (_super) {
        __extends(Numbers, _super);
        function Numbers() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._intTool = null;
            return _this;
        }
        Numbers.prototype.getIntegers = function () {
            if (this._intTool === null) {
                this._intTool = new Integers();
                this._intTool.setAuto(this.getAuto());
            }
            return this._intTool;
        };
        return Numbers;
    }(BaseFactory));

    var RegExs = /** @class */ (function (_super) {
        __extends(RegExs, _super);
        function RegExs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //Use:
        //var any	= something.getAuto().get("utilities").getExpressions().getRegEx().__METHOD__();
        RegExs.prototype.makeSafe = function (str) {
            if (typeof str !== "string") {
                throw this.getAuto().newException("Invalid input, only accepts strings");
            }
            return str.replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
        };
        return RegExs;
    }(BaseTool));

    var Expressions = /** @class */ (function (_super) {
        __extends(Expressions, _super);
        function Expressions() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._regExs = null;
            return _this;
        }
        Expressions.prototype.getRegEx = function () {
            if (this._regExs === null) {
                this._regExs = new RegExs();
                this._regExs.setAuto(this.getAuto());
            }
            return this._regExs;
        };
        return Expressions;
    }(BaseFactory));

    var Strings$2 = /** @class */ (function (_super) {
        __extends(Strings, _super);
        function Strings() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._trackers = {};
            return _this;
        }
        Strings.prototype.toStr = function (obj, id, depDelim) {
            if (id === void 0) { id = null; }
            if (depDelim === void 0) { depDelim = null; }
            var id;
            return __awaiter(this, void 0, void 0, function () {
                var isinit, isArr, eObj, rObj, _a, _b, _i, key, value, found, eId, _c, _d, _e, _f, errObj_1;
                return __generator(this, function (_g) {
                    switch (_g.label) {
                        case 0:
                            //remove circular dependencies so any object can be stringified
                            if (typeof obj !== "object") {
                                throw this.getAuto().newException("Invalid input");
                            }
                            isinit = false;
                            if (id === null) {
                                isinit = true;
                                id = this.getAuto().get("utilities").getStrings().getRandom().getByRegex(12);
                                this._trackers[id] = { "objs": [] };
                            }
                            _g.label = 1;
                        case 1:
                            _g.trys.push([1, 14, , 15]);
                            isArr = null;
                            eObj = null;
                            rObj = null;
                            if (Array.isArray(obj) === true) {
                                isArr = true;
                                rObj = [];
                            }
                            else {
                                isArr = false;
                                rObj = {};
                            }
                            _a = [];
                            for (_b in obj)
                                _a.push(_b);
                            _i = 0;
                            _g.label = 2;
                        case 2:
                            if (!(_i < _a.length)) return [3 /*break*/, 13];
                            key = _a[_i];
                            value = obj[key];
                            if (!(value instanceof Node)) return [3 /*break*/, 3];
                            return [3 /*break*/, 12];
                        case 3:
                            if (!(value instanceof Window)) return [3 /*break*/, 4];
                            return [3 /*break*/, 12];
                        case 4:
                            if (!(typeof value === "object")) return [3 /*break*/, 11];
                            found = false;
                            for (eId in this._trackers[id]["objs"]) {
                                if (this._trackers[id]["objs"][eId] === value) {
                                    found = true;
                                }
                            }
                            if (!(found === false)) return [3 /*break*/, 9];
                            this._trackers[id]["objs"].push(value);
                            if (!(isArr === false)) return [3 /*break*/, 6];
                            _c = rObj;
                            _d = key;
                            return [4 /*yield*/, this.toStr(value, id, depDelim)];
                        case 5:
                            _c[_d] = _g.sent();
                            return [3 /*break*/, 8];
                        case 6:
                            _f = (_e = rObj).push;
                            return [4 /*yield*/, this.toStr(value, id, depDelim)];
                        case 7:
                            _f.apply(_e, [_g.sent()]);
                            _g.label = 8;
                        case 8: return [3 /*break*/, 10];
                        case 9:
                            if (depDelim !== null) {
                                if (isArr === false) {
                                    rObj[key] = depDelim;
                                }
                                else {
                                    rObj.push(depDelim);
                                }
                            }
                            _g.label = 10;
                        case 10: return [3 /*break*/, 12];
                        case 11:
                            if (isArr === false) {
                                rObj[key] = value;
                            }
                            else {
                                rObj.push(value);
                            }
                            _g.label = 12;
                        case 12:
                            _i++;
                            return [3 /*break*/, 2];
                        case 13:
                            if (isinit === true) {
                                delete this._trackers[id];
                                return [2 /*return*/, JSON.stringify(rObj)];
                            }
                            else {
                                return [2 /*return*/, rObj];
                            }
                            return [3 /*break*/, 15];
                        case 14:
                            errObj_1 = _g.sent();
                            if (isinit === true && typeof this._trackers[id] !== "undefined") {
                                delete this._trackers[id];
                            }
                            throw errObj_1;
                        case 15: return [2 /*return*/];
                    }
                });
            });
        };
        return Strings;
    }(BaseTool));

    var Types = /** @class */ (function (_super) {
        __extends(Types, _super);
        function Types() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //USE: this.getAuto().get("utilities").getObjects().getTypes().__METHOD__();
        Types.prototype.isValid = function (input, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            if (typeof input === "object" && input !== null) {
                return true;
            }
            else if (throwOnErr === true) {
                throw this.getAuto().newException("Input is not an object", 7887);
            }
            else {
                return false;
            }
        };
        return Types;
    }(BaseTool));

    var Objects$1 = /** @class */ (function (_super) {
        __extends(Objects, _super);
        function Objects() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._strTool = null;
            _this._typesTool = null;
            return _this;
        }
        Objects.prototype.getStrings = function () {
            if (this._strTool === null) {
                this._strTool = new Strings$2();
                this._strTool.setAuto(this.getAuto());
            }
            return this._strTool;
        };
        Objects.prototype.getTypes = function () {
            if (this._typesTool === null) {
                this._typesTool = new Types();
                this._typesTool.setAuto(this.getAuto());
            }
            return this._typesTool;
        };
        return Objects;
    }(BaseFactory));

    var Promises = /** @class */ (function (_super) {
        __extends(Promises, _super);
        function Promises() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Promises.prototype.getInline = function () {
            //allows creation of a promise and continue work outside the promise
            //helpful in async functions
            //you can return the promise to the end user
            //do some work and when ready place the return value / data 
            //piObj["data"] = {"someThing": "anotherThing"}
            //then either piObj["resolve"]() or piObj["reject"]()
            //you can also just do: piObj["resolve"](data) or piObj["reject"](errObj)
            var piObj = { "promise": null, "resolve": null, "reject": null, data: null };
            piObj["promise"] = new Promise(function (resolve, reject) {
                piObj["resolve"] = function (data) {
                    if (data === void 0) { data = null; }
                    if (piObj["data"] === null) {
                        resolve(data);
                    }
                    else {
                        resolve(piObj["data"]);
                    }
                    ;
                };
                piObj["reject"] = function (data) {
                    if (data === void 0) { data = null; }
                    if (piObj["data"] === null) {
                        reject(data);
                    }
                    else {
                        reject(piObj["data"]);
                    }
                    ;
                };
            });
            return piObj;
        };
        return Promises;
    }(BaseTool));

    var Async = /** @class */ (function (_super) {
        __extends(Async, _super);
        function Async() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._promiseTool = null;
            return _this;
        }
        Async.prototype.getPromises = function () {
            if (this._promiseTool === null) {
                this._promiseTool = new Promises();
                this._promiseTool.setAuto(this.getAuto());
            }
            return this._promiseTool;
        };
        return Async;
    }(BaseFactory));

    var SHA = /** @class */ (function (_super) {
        __extends(SHA, _super);
        function SHA() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //USE: this.getAuto().get("utilities").getHashing().getSHA().__METHOD__();
        SHA.prototype.get256 = function (input) {
            return __awaiter(this, void 0, void 0, function () {
                var dataBuff, digest;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (typeof crypto.subtle === "undefined") {
                                throw this.getAuto().newException("Browser crypto is only available in a secure context (https)");
                            }
                            dataBuff = this.getAuto().get("utilities").getStrings().getArrays().toBuffer(input);
                            return [4 /*yield*/, crypto.subtle.digest("SHA-256", dataBuff)];
                        case 1:
                            digest = _a.sent();
                            return [2 /*return*/, Array.from(new Uint8Array(digest)).map(function (b) { return b.toString(16).padStart(2, "0"); }).join("")];
                    }
                });
            });
        };
        SHA.prototype.is256 = function (input, base, throwOnErr) {
            if (base === void 0) { base = 16; }
            if (throwOnErr === void 0) { throwOnErr = false; }
            var isValid = true;
            if (typeof input === "string") {
                if (base === 16) {
                    if (input.length !== 64) {
                        isValid = false;
                    }
                    else {
                        var regex = /^[a-f0-9]+$/;
                        if (input.match(regex) === null) {
                            isValid = false;
                        }
                    }
                }
                else {
                    throw this.getAuto().newException("Not handled for base: " + base);
                }
            }
            else {
                isValid = false;
            }
            if (isValid === true) {
                return true;
            }
            else if (throwOnErr === true) {
                throw this.getAuto().newException("Invalid sha256 hash", 7870);
            }
            else {
                return false;
            }
        };
        return SHA;
    }(BaseTool));

    var Hashing = /** @class */ (function (_super) {
        __extends(Hashing, _super);
        function Hashing() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._shaTool = null;
            return _this;
        }
        Hashing.prototype.getSHA = function () {
            if (this._shaTool === null) {
                this._shaTool = new SHA();
                this._shaTool.setAuto(this.getAuto());
            }
            return this._shaTool;
        };
        return Hashing;
    }(BaseFactory));

    var Ports = /** @class */ (function (_super) {
        __extends(Ports, _super);
        function Ports() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //Use: this.getAuto().get("utilities").getNetwork().getPorts().__METHOD__();
        Ports.prototype.isSecureOpen = function (host, port, timeout) {
            if (timeout === void 0) { timeout = 500; }
            //make async instead
            var pObj = this.getAuto().get("utilities").getAsync().getPromises().getInline();
            var timeInt = setTimeout(function () {
                if (pObj["data"] === null) {
                    pObj["data"] = false;
                    pObj["resolve"]();
                }
            }, timeout);
            var url = "https://" + host + ":" + port;
            fetch(url, { method: "GET", mode: "no-cors", cache: "no-cache", redirect: "follow" }).then(function (resp) {
                clearTimeout(timeInt);
                if (pObj["data"] === null) {
                    pObj["data"] = true;
                    pObj["resolve"]();
                }
            }, function (errObj) {
                clearTimeout(timeInt);
                if (pObj["data"] === null) {
                    pObj["data"] = false;
                    pObj["resolve"]();
                }
            });
            return pObj.promise;
        };
        return Ports;
    }(BaseTool));

    var IPs = /** @class */ (function (_super) {
        __extends(IPs, _super);
        function IPs() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //Use: this.getAuto().get("utilities").getNetwork().getIPs().__METHOD__();
        IPs.prototype.isV4 = function (input, throwOnErr) {
            if (throwOnErr === void 0) { throwOnErr = false; }
            if (typeof input === "string") {
                var regEx = RegExp(/^([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})$/);
                if (regEx.test(input) === true) {
                    var octets = input.match(regEx);
                    if (parseInt(octets[1]) < 256 && parseInt(octets[2]) < 256 && parseInt(octets[3]) < 256 && parseInt(octets[4]) < 256) {
                        return true;
                    }
                }
            }
            if (throwOnErr === true) {
                throw this.getAuto().newException("Input is not an ipv4 address", 7878);
            }
            else {
                return false;
            }
        };
        return IPs;
    }(BaseTool));

    var Networks = /** @class */ (function (_super) {
        __extends(Networks, _super);
        function Networks() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._ports = null;
            _this._ips = null;
            return _this;
        }
        Networks.prototype.getPorts = function () {
            if (this._ports === null) {
                this._ports = new Ports();
                this._ports.setAuto(this.getAuto());
            }
            return this._ports;
        };
        Networks.prototype.getIPs = function () {
            if (this._ips === null) {
                this._ips = new IPs();
                this._ips.setAuto(this.getAuto());
            }
            return this._ips;
        };
        return Networks;
    }(BaseFactory));

    var Current = /** @class */ (function (_super) {
        __extends(Current, _super);
        function Current() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Current.prototype.getMicroEpoch = function (float) {
            if (float === void 0) { float = true; }
            var curTime = new Date();
            var mEpoch = curTime.getTime() / 1000;
            if (float === true) {
                //all numbers in JS are stored as double precision floating point
                return mEpoch;
            }
            else {
                //fixed length, need to account for no .
                return mEpoch.toString() + "0".repeat((17 - mEpoch.toString().length));
            }
        };
        Current.prototype.getEpoch = function () {
            var curTime = new Date();
            return Math.floor(curTime.getTime() / 1000);
        };
        Current.prototype.getFormatted = function (format) {
            if (format === void 0) { format = ""; }
            return this.getAuto().get("utilities").getTime().getFormatter().fromEpoch(this.getEpoch(), format);
        };
        return Current;
    }(BaseTool));

    var Formatter = /** @class */ (function (_super) {
        __extends(Formatter, _super);
        function Formatter() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Formatter.prototype.getObjFromEpoch = function (epoch) {
            var int = parseInt(epoch);
            var dateObj = new Date(0);
            dateObj.setUTCSeconds(int);
            return dateObj;
        };
        Formatter.prototype.fromEpoch = function (epoch, format) {
            if (format === void 0) { format = ""; }
            var pObj = this.getParts(epoch);
            format = format.replace("H", pObj["H"]);
            format = format.replace("h", pObj["h"]);
            format = format.replace("i", pObj["i"]);
            format = format.replace("A", pObj["A"]);
            format = format.replace("T", pObj["T"]);
            format = format.replace("m", pObj["m"]);
            format = format.replace("Y", pObj["Y"]);
            format = format.replace("n", pObj["n"]);
            format = format.replace("d", pObj["d"]);
            format = format.replace("i", pObj["i"]);
            format = format.replace("s", pObj["s"]);
            format = format.replace("a", pObj["a"]);
            return format;
        };
        Formatter.prototype.getParts = function (epoch) {
            var dateObj = this.getObjFromEpoch(epoch);
            var rObj = {};
            rObj["Y"] = dateObj.getFullYear(); //A full numeric representation of a year, 4 digits
            rObj["n"] = dateObj.getMonth() + 1; //Numeric representation of a month, without leading zeros
            rObj["m"] = dateObj.getMonth() + 1; //Numeric representation of a month, with leading zeros
            if (rObj["m"] < 10) {
                rObj["m"] = "0" + rObj["m"];
            }
            rObj["j"] = dateObj.getDate(); //Day of the month without leading zeros
            rObj["d"] = dateObj.getDate(); //Day of the month, 2 digits with leading zeros
            if (rObj["d"] < 10) {
                rObj["d"] = "0" + rObj["d"];
            }
            rObj["i"] = dateObj.getMinutes(); //Minutes with leading zeros
            if (rObj["i"] < 10) {
                rObj["i"] = "0" + rObj["i"];
            }
            rObj["s"] = dateObj.getSeconds(); //Seconds with leading zeros
            if (rObj["s"] < 10) {
                rObj["s"] = "0" + rObj["s"];
            }
            rObj["H"] = dateObj.getHours(); //24-hour format of an hour with leading zeros
            if (rObj["H"] < 10) {
                rObj["H"] = "0" + rObj["H"];
            }
            rObj["h"] = dateObj.getHours(); //12-hour format of an hour with leading zeros
            if (rObj["h"] > 12) {
                rObj["h"] = rObj["h"] - 12;
            }
            if (rObj["h"] < 10) {
                rObj["h"] = "0" + rObj["h"];
            }
            rObj["a"] = "am";
            if (rObj["H"] > 12) {
                rObj["a"] = "pm";
            }
            rObj["A"] = rObj["a"].toUpperCase();
            rObj["T"] = "UNKNOWN";
            //src: https://stackoverflow.com/questions/1954397/detect-timezone-abbreviation-using-javascript
            try {
                rObj["T"] = /.*\s([A-Z]+)/.exec(dateObj.toLocaleDateString(navigator.language, { timeZoneName: 'short' }))[1];
            }
            catch (e) {
                rObj["T"] = dateObj.toTimeString().match(new RegExp("[A-Z](?!.*[\(])", "g")).join('');
            }
            return rObj;
        };
        return Formatter;
    }(BaseTool));

    var Time = /** @class */ (function (_super) {
        __extends(Time, _super);
        function Time() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._curTool = null;
            _this._formatTool = null;
            return _this;
        }
        Time.prototype.getMicroEpoch = function (asFloat) {
            if (asFloat === void 0) { asFloat = true; }
            //shortcut alias
            return this.getCurrent().getMicroEpoch(asFloat);
        };
        Time.prototype.getCurrent = function () {
            if (this._curTool === null) {
                this._curTool = new Current();
                this._curTool.setAuto(this.getAuto());
            }
            return this._curTool;
        };
        Time.prototype.getFormatter = function () {
            if (this._formatTool === null) {
                this._formatTool = new Formatter();
                this._formatTool.setAuto(this.getAuto());
            }
            return this._formatTool;
        };
        return Time;
    }(BaseFactory));

    var Touch = /** @class */ (function (_super) {
        __extends(Touch, _super);
        function Touch() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._isSupported = null;
            return _this;
        }
        Touch.prototype.isSupported = function () {
            if (this._isSupported === null) {
                //src: https://stackoverflow.com/questions/6262584/how-to-determine-if-the-client-is-a-touch-device
                var el = document.createElement("div");
                el.setAttribute("ongesturestart", "return;"); // or try "ontouchstart"
                try {
                    this._isSupported = typeof el["ongesturestart"] === "function";
                }
                catch (e) {
                    this._isSupported = false;
                }
                try {
                    el.parentNode.removeChild(el);
                }
                catch (e) {
                }
            }
            return this._isSupported;
        };
        return Touch;
    }(BaseTool));

    var Clipboard = /** @class */ (function (_super) {
        __extends(Clipboard, _super);
        function Clipboard() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //var promise	= something.getAuto().get("utilities").getUi().getClipboard().set("myVal", true);
        Clipboard.prototype.set = function (value, doThrow) {
            var _this = this;
            if (doThrow === void 0) { doThrow = true; }
            var pObj = this.getAuto().newPromise();
            var pObj2 = this.getAuto().newPromise();
            if (typeof navigator.clipboard !== "undefined") {
                navigator.clipboard.writeText(value).then(function () {
                    pObj2["resolve"](true);
                }, function (errObj) {
                    pObj2["resolve"](false);
                });
            }
            else {
                pObj2["resolve"](false);
            }
            pObj2.promise.then(function (bool) {
                if (bool === false) {
                    //fall back, input element
                    var el = document.createElement("input");
                    el.value = value;
                    el.style.top = "0";
                    el.style.left = "0";
                    el.style.opacity = "0";
                    el.style.position = "fixed";
                    el.contentEditable = 'true';
                    el.readOnly = false;
                    document.body.appendChild(el);
                    el.select();
                    el.focus();
                    el.setSelectionRange(0, 999999);
                    var res = document.execCommand('copy');
                    el.blur();
                    document.body.removeChild(el);
                    if (res === false) {
                        //fall back, text area
                        var el2 = document.createElement("textarea");
                        el2.value = value;
                        el2.style.top = "0";
                        el2.style.left = "0";
                        el2.style.opacity = "0";
                        el2.style.position = "fixed";
                        document.body.appendChild(el2);
                        el2.focus();
                        el2.select();
                        var res = document.execCommand('copy');
                        document.body.removeChild(el2);
                        if (res === false) {
                            if (doThrow === true) {
                                pObj["reject"](_this.getAuto().newException("Failed to set clipboard value"));
                            }
                            else {
                                pObj["resolve"](false);
                            }
                        }
                        else {
                            pObj["resolve"](true);
                        }
                    }
                    else {
                        pObj["resolve"](true);
                    }
                }
                else {
                    pObj["resolve"](true);
                }
            });
            return pObj.promise;
        };
        Clipboard.prototype.get = function (doThrow) {
            var _this = this;
            if (doThrow === void 0) { doThrow = true; }
            var pObj = this.getAuto().newPromise();
            var pObj2 = this.getAuto().newPromise();
            if (typeof navigator.clipboard !== "undefined") {
                navigator.clipboard.readText().then(function (value) {
                    pObj2["resolve"](value);
                }, function (errObj) {
                    pObj2["resolve"]("mtm-unable-to-copy-content44xx");
                });
            }
            else {
                pObj2["resolve"]("mtm-unable-to-copy-content44xx");
            }
            pObj2.promise.then(function (value) {
                if (value === "mtm-unable-to-copy-content44xx") {
                    //fall back
                    var textArea = document.createElement("textarea");
                    textArea.value = value;
                    textArea.style.top = "0";
                    textArea.style.left = "0";
                    textArea.style.opacity = "0";
                    textArea.style.position = "fixed";
                    document.body.appendChild(textArea);
                    textArea.focus();
                    textArea.select();
                    var res = document.execCommand("paste", null, null);
                    value = textArea.value;
                    document.body.removeChild(textArea);
                    if (res === false) {
                        if (doThrow === true) {
                            pObj["reject"](_this.getAuto().newException("Failed to get clipboard value"));
                        }
                        else {
                            pObj["resolve"](false);
                        }
                    }
                    else {
                        pObj["resolve"](value);
                    }
                }
                else {
                    pObj["resolve"](value);
                }
            });
            return pObj.promise;
        };
        return Clipboard;
    }(BaseTool));

    var Ui = /** @class */ (function (_super) {
        __extends(Ui, _super);
        function Ui() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._touchTool = null;
            _this._clipTool = null;
            return _this;
        }
        Ui.prototype.getTouch = function () {
            if (this._touchTool === null) {
                this._touchTool = new Touch();
                this._touchTool.setAuto(this.getAuto());
            }
            return this._touchTool;
        };
        Ui.prototype.getClipboard = function () {
            if (this._clipTool === null) {
                this._clipTool = new Clipboard();
                this._clipTool.setAuto(this.getAuto());
            }
            return this._clipTool;
        };
        return Ui;
    }(BaseFactory));

    var Exception = /** @class */ (function (_super) {
        __extends(Exception, _super);
        function Exception(msg, code) {
            if (msg === void 0) { msg = null; }
            if (code === void 0) { code = null; }
            var _this = _super.call(this, msg) || this;
            //adding auto to exception results in ERROR TypeError: "cyclic object value" when thrown
            _this._msg = null;
            _this._code = 0;
            Object.setPrototypeOf(_this, Exception.prototype);
            if (msg !== null) {
                _this._msg = msg;
            }
            if (code !== null) {
                _this._code = code;
            }
            return _this;
        }
        Exception.prototype.getMessage = function () {
            return this._msg;
        };
        Exception.prototype.getCode = function () {
            return this._code;
        };
        return Exception;
    }(Error));

    var Exceptions = /** @class */ (function (_super) {
        __extends(Exceptions, _super);
        function Exceptions() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Exceptions.prototype.get = function (msg, code) {
            if (msg === void 0) { msg = null; }
            if (code === void 0) { code = null; }
            var rObj = new Exception(msg, code);
            //adding auto to exception results in ERROR TypeError: "cyclic object value" when thrown
            //rObj.setAuto(this.getAuto());
            return rObj;
        };
        return Exceptions;
    }(BaseFactory));

    var Cookies = /** @class */ (function (_super) {
        __extends(Cookies, _super);
        function Cookies() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //Use:
        //var bool	= something.getAuto().get("utilities").getStorage().getCookies().getRootDomain();
        //note:A cookie can contains data upto 4096 Bytes only that is the maximum size of a cookie which can be. 
        //If you want to support most browsers, then do not exceed 50 cookies per domain, and 4093 bytes per domain. 
        //That is, the size of all cookies should not exceed 4096 bytes.
        Cookies.prototype.getRootDomain = function () {
            var host = document.location.hostname;
            var res = host.match(/([^\.]+\.[^\.0-9]+|[^\.]+)$/);
            if (res !== null) {
                return "." + res[0];
            }
            else {
                throw this.getAuto().newException("Cannot determine current root domain");
            }
        };
        return Cookies;
    }(BaseTool));

    var BaseModel = /** @class */ (function () {
        function BaseModel() {
            this._mtmAuto = null;
        }
        BaseModel.prototype.setAuto = function (service) {
            this._mtmAuto = service;
            return this;
        };
        BaseModel.prototype.getAuto = function () {
            return this._mtmAuto;
        };
        return BaseModel;
    }());

    var Cookie = /** @class */ (function (_super) {
        __extends(Cookie, _super);
        function Cookie() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._toolObj = null;
            _this._name = null; //name
            _this._value = null; //data
            _this._path = "/"; //path
            _this._expires = null; //time to delete, maxAge use setExpiresSecs(secs)
            _this._domain = null; //domain access
            _this._secure = true; //https only
            _this._httpOnly = false; //no JS access
            _this._sameSite = "strict";
            return _this;
        }
        Cookie.prototype.getName = function () {
            return this._name;
        };
        Cookie.prototype.setName = function (name) {
            this._name = name;
            return this;
        };
        Cookie.prototype.getDomain = function () {
            return this._domain;
        };
        Cookie.prototype.setDomain = function (value) {
            this._domain = value;
            return this;
        };
        Cookie.prototype.getValue = function () {
            return this._value;
        };
        Cookie.prototype.setValue = function (value) {
            this._value = value;
            return this;
        };
        Cookie.prototype.getValueObj = function (doThrow) {
            if (doThrow === void 0) { doThrow = false; }
            try {
                return JSON.parse(atob(this.getValue()));
            }
            catch (e) {
                if (doThrow === true) {
                    throw this.getAuto().newException(e);
                }
                else {
                    return null;
                }
            }
        };
        Cookie.prototype.setValueObj = function (obj) {
            this._value = btoa(JSON.stringify(obj));
            return this;
        };
        Cookie.prototype.getPath = function () {
            return this._path;
        };
        Cookie.prototype.setPath = function (path) {
            this._path = path;
            return this;
        };
        Cookie.prototype.getSameSite = function () {
            return this._sameSite;
        };
        Cookie.prototype.setSameSite = function (value) {
            if (/(strict|lax)/.test(value) === false) {
                throw this.getAuto().newException("Invalid input: " + value);
            }
            this._sameSite = value;
            return this;
        };
        Cookie.prototype.getHttpOnly = function () {
            return this._httpOnly;
        };
        Cookie.prototype.setHttpOnly = function (bool) {
            if (bool !== false && bool !== true) {
                throw this.getAuto().newException("Invalid input");
            }
            this._httpOnly = bool;
            return this;
        };
        Cookie.prototype.getSecure = function () {
            return this._secure;
        };
        Cookie.prototype.setSecure = function (bool) {
            if (bool !== false && bool !== true) {
                throw this.getAuto().newException("Invalid input");
            }
            this._secure = bool;
            return this;
        };
        Cookie.prototype.setExpiresSecs = function (secs) {
            this._expires = Math.ceil((this.getAuto().getEpoch() + secs));
            return this;
        };
        Cookie.prototype.setExpiresDays = function (days) {
            this.setExpiresSecs(days * 24 * 60 * 60);
            return this;
        };
        Cookie.prototype.getExpires = function () {
            //not available on pull
            //src: https://stackoverflow.com/questions/3274875/how-to-get-cookie-expiration-date-creation-date-from-javascript
            return this._expires;
        };
        Cookie.prototype.push = function () {
            if (this.getName() === null) {
                throw this.getAuto().newException("Cannot push without a name");
            }
            var str = this.getName();
            str += "=" + this.getValue() + ";";
            if (this.getExpires() !== null) {
                var expires = this.getAuto().get("utilities").getTime().getFormatter().getObjFromEpoch(this.getExpires()).toUTCString();
                str += " expires=" + expires + ";";
            }
            if (this.getPath() !== null) {
                str += " path=" + this.getPath() + ";";
            }
            if (this.getDomain() !== null) {
                str += " domain=" + this.getDomain() + ";";
            }
            if (this.getSameSite() !== null) {
                str += " samesite=" + this.getSameSite() + ";";
            }
            if (this.getSecure() === true) {
                str += " secure;";
            }
            if (this.getHttpOnly() === true) {
                str += " httpOnly;";
            }
            document.cookie = str;
            return this;
        };
        Cookie.prototype.pull = function (doThrow) {
            if (doThrow === void 0) { doThrow = false; }
            if (this.getName() === null) {
                throw this.getAuto().newException("Cannot pull without a name");
            }
            else if (this.getExists(doThrow) === false) {
                //cookie does not exist and user does not want to throw
                return this;
            }
            var items = decodeURIComponent(document.cookie).split(';');
            var iLen = items.length;
            for (var i = 0; i < iLen; i++) {
                var str = items[i];
                var index = str.indexOf('=');
                var name = str.slice(0, index).trim();
                if (name === this.getName()) {
                    var value = str.slice(index + 1);
                    this.setValue(value);
                    break;
                }
            }
            return this;
        };
        Cookie.prototype.getExists = function (doThrow) {
            if (doThrow === void 0) { doThrow = false; }
            var items = decodeURIComponent(document.cookie).split(';');
            var iLen = items.length;
            for (var i = 0; i < iLen; i++) {
                var str = items[i];
                var index = str.indexOf('=');
                var name = str.slice(0, index).trim();
                if (name === this.getName()) {
                    return true;
                }
            }
            if (doThrow === true) {
                throw this.getAuto().newException("Cookie does not exist");
            }
            else {
                return false;
            }
        };
        Cookie.prototype.delete = function () {
            if (this.getExists() === true) {
                this.setExpiresSecs(-1).push();
            }
        };
        Cookie.prototype.setTool = function (tool) {
            this._toolObj = tool;
            return this;
        };
        Cookie.prototype.getTool = function () {
            return this._toolObj;
        };
        return Cookie;
    }(BaseModel));

    var Storage = /** @class */ (function (_super) {
        __extends(Storage, _super);
        function Storage() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._cookieTool = null;
            return _this;
        }
        Storage.prototype.getCookie = function (name) {
            if (name === void 0) { name = null; }
            var rObj = new Cookie();
            rObj.setAuto(this.getAuto()).setTool(this.getCookieTool());
            if (name !== null) {
                rObj.setName(name);
            }
            return rObj;
        };
        Storage.prototype.getCookieTool = function () {
            if (this._cookieTool === null) {
                this._cookieTool = new Cookies();
                this._cookieTool.setAuto(this.getAuto());
            }
            return this._cookieTool;
        };
        return Storage;
    }(BaseFactory));

    var MtmUtilities = /** @class */ (function () {
        function MtmUtilities() {
            this._mtmAuto = null;
            this._guidsFact = null;
            this._arrFact = null;
            this._strFact = null;
            this._numFact = null;
            this._expFact = null;
            this._objFact = null;
            this._asyncFact = null;
            this._hashFact = null;
            this._netFact = null;
            this._timeFact = null;
            this._uiFact = null;
            this._excepFact = null;
            this._storeFact = null;
        }
        MtmUtilities.prototype.setAuto = function (mtmAuto) {
            this._mtmAuto = mtmAuto;
            this.getAuto().set("utilities", this);
            return this;
        };
        MtmUtilities.prototype.getAuto = function () {
            return this._mtmAuto;
        };
        MtmUtilities.prototype.getGuids = function () {
            if (this._guidsFact === null) {
                this._guidsFact = new Guids();
                this._guidsFact.setAuto(this.getAuto());
            }
            return this._guidsFact;
        };
        MtmUtilities.prototype.getArrays = function () {
            if (this._arrFact === null) {
                this._arrFact = new Arrays();
                this._arrFact.setAuto(this.getAuto());
            }
            return this._arrFact;
        };
        MtmUtilities.prototype.getStrings = function () {
            if (this._strFact === null) {
                this._strFact = new Strings$1();
                this._strFact.setAuto(this.getAuto());
            }
            return this._strFact;
        };
        MtmUtilities.prototype.getNumbers = function () {
            if (this._numFact === null) {
                this._numFact = new Numbers();
                this._numFact.setAuto(this.getAuto());
            }
            return this._numFact;
        };
        MtmUtilities.prototype.getExpressions = function () {
            if (this._expFact === null) {
                this._expFact = new Expressions();
                this._expFact.setAuto(this.getAuto());
            }
            return this._expFact;
        };
        MtmUtilities.prototype.getObjects = function () {
            if (this._objFact === null) {
                this._objFact = new Objects$1();
                this._objFact.setAuto(this.getAuto());
            }
            return this._objFact;
        };
        MtmUtilities.prototype.getAsync = function () {
            if (this._asyncFact === null) {
                this._asyncFact = new Async();
                this._asyncFact.setAuto(this.getAuto());
            }
            return this._asyncFact;
        };
        MtmUtilities.prototype.getHashing = function () {
            if (this._hashFact === null) {
                this._hashFact = new Hashing();
                this._hashFact.setAuto(this.getAuto());
            }
            return this._hashFact;
        };
        MtmUtilities.prototype.getNetwork = function () {
            if (this._netFact === null) {
                this._netFact = new Networks();
                this._netFact.setAuto(this.getAuto());
            }
            return this._netFact;
        };
        MtmUtilities.prototype.getTime = function () {
            if (this._timeFact === null) {
                this._timeFact = new Time();
                this._timeFact.setAuto(this.getAuto());
            }
            return this._timeFact;
        };
        MtmUtilities.prototype.getUi = function () {
            if (this._uiFact === null) {
                this._uiFact = new Ui();
                this._uiFact.setAuto(this.getAuto());
            }
            return this._uiFact;
        };
        MtmUtilities.prototype.getExceptions = function () {
            if (this._excepFact === null) {
                this._excepFact = new Exceptions();
                this._excepFact.setAuto(this.getAuto());
            }
            return this._excepFact;
        };
        MtmUtilities.prototype.getStorage = function () {
            if (this._storeFact === null) {
                this._storeFact = new Storage();
                this._storeFact.setAuto(this.getAuto());
            }
            return this._storeFact;
        };
        return MtmUtilities;
    }());
    MtmUtilities.ɵprov = i0.ɵɵdefineInjectable({ factory: function MtmUtilities_Factory() { return new MtmUtilities(); }, token: MtmUtilities, providedIn: "root" });
    MtmUtilities.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];

    /*
     * Public API Surface of mtm-utilities
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.MtmUtilities = MtmUtilities;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=mtm-utilities.umd.js.map
